const el = document.createElement("div");

el.style = `
  padding: 10px;
`

el.innerHTML = `
<button id="Home"> Home</button>
<p>
<button id="Move"> Move</button>
<p>
<button id="LoopAround"> Loop Around</button>
`;

el
  .querySelector("#Home")
  .addEventListener("click", () => {
    goToHome();
  })

el
  .querySelector("#Move")
  .addEventListener("click", () => {
    delay(100);
    move();
  })

el
  .querySelector("#LoopAround")
  .addEventListener("click", () => {
    delay(100);
    loopAround();
  })

render(el);



// assuming we have a `simple` motor as `motor.`
let motor = xMotor

// the extent of our axis, in whatever units, 
let extent = 130

// a speed to move around at 
let speed = 200


// how many steps (of the motor, 200 per motor revolution) for one of our units ?
// in i.e. the rotary axis, we have 200 revs, plus a 125:20 reduction (6.25)
// that's 1250 steps per output revolution, and we'd like to use degrees, so:
let stepsPerUnit = 1250 / 360

// the amount of motor-power to use: 0 for none, 1.0 for all of it, 
let motorCurrent = 1.0  

// acceleration to use, units/sec/sec 
let accel = 200

let setup = async () => {
  console.log(`setting up the motor...`)
  await motor.setCurrent(motorCurrent);
  await motor.setStepsPerUnit(stepsPerUnit);
  await motor.setAccel(accel);
}

let shutDown = async () => {
  console.log(`shutting down the motor...`)
  await motor.setCurrent(0);
}

let goToHome = async () => {
  setup();

  console.log("Moving towards endstop button");
  while(await motor.getLimitState()){
    motor.velocity(-10);
  }
  
  console.log("Moving off endstop button");
  while(!await motor.getLimitState()){
    motor.velocity(10);
  }

  motor.setPosition(0);
  console.log("Motor is at Home");
  motor.stop();
}

let move = async () => {
  setup();

  //Moving to absolute location (location,speed)
  console.log("Moving forward");
  console.log(motor.getState());

  await motor.absolute(extent, speed);
  console.log(motor.getState());
  shutDown();
  await delay(1000);
  setup();
  console.log("Moving back");
  await motor.absolute(0, 200);

  shutDown();
  
}

let loopAround = async () => {
  setup();

  //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(extent, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(0, 200);
  await delay(50);


  //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(120, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(10, 200);
  await delay(50);

  //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(110, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(20, 200);
  await delay(50);

  //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(100, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(30, 200);
  await delay(50);

    //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(90, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(40, 200);
  await delay(50);

    //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(80, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(50, 200);
  await delay(50);

    //Moving to absolute location (location,speed)
  console.log("Moving forward");
  await motor.absolute(70, speed);
  shutDown();
  await delay(50);
  setup();
  console.log("Moving back");
  await motor.absolute(60, 200);

  await delay(50);
  await motor.absolute(130, 200);
  await delay(50);

  await motor.absolute(0, 200);

  
  shutDown();
  
}